presentation/src/main/java/omnidoc/presentation/model/charts/DonutChartView.java
package omnidoc.presentation.model.charts;

import omnidoc.business.domain.site.NetworkSite;
import omnidoc.business.domain.topology.ComponentType;
import omnidoc.business.domain.topology.NetworkComponent;
import omnidoc.business.services.site.SiteService;
import omnidoc.presentation.manager.SiteManager;
import omnidoc.presentation.util.Resources;
import org.primefaces.model.chart.DonutChartModel;

import javax.annotation.PostConstruct;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.Set;

@Named
@ViewScoped
public class DonutChartView implements Serializable {

    private static final long serialVersionUID = -5816176710866257767L;

    private DonutChartModel donutModel;

    @Inject
    private SiteService siteService;

    @PostConstruct
    public void init() {
        donutModel = createDonutModel();
    }

    public DonutChartModel getDonutModel() {
        return donutModel;
    }

    public void setDonutModel(DonutChartModel donutModel) {
        this.donutModel = donutModel;
    }

    private DonutChartModel createDonutModel() {
        DonutChartModel model = initDonutModel();
        ResourceBundle bundle = Resources.getMessageBundle(Resources.dashboardBundle);

        model.setTitle(bundle.getString("panel.chart.components"));
        model.setLegendPosition("w");

        model.setShowDataLabels(true);
        model.setDataFormat("value");
        return model;
    }

    private DonutChartModel initDonutModel() {
        DonutChartModel model = new DonutChartModel();

        NetworkSite site = siteService.findById(SiteManager.getCurrentSite().getId());
        if (site.getTopology() == null) return model;

        Set<NetworkComponent> components = site.getTopology().getComponents();
        Map<String, Number> componentCircle = new LinkedHashMap<>();
        for (ComponentType componentType : ComponentType.values()) {
            componentCircle.put(
                    componentType.name(),
                    components.stream()
                            .filter(c -> c.getType() == componentType)
                            .count());
        }
        model.addCircle(componentCircle);

        return model;
    }
}

presentation/src/main/java/omnidoc/presentation/model/components/ComponentView.java
package omnidoc.presentation.model.components;


import omnidoc.business.domain.site.NetworkSite;
import omnidoc.business.domain.topology.ComponentType;
import omnidoc.business.domain.topology.NetworkComponent;
import omnidoc.business.services.components.ComponentService;
import omnidoc.business.services.site.SiteService;
import omnidoc.presentation.exporter.ExportType;
import omnidoc.presentation.manager.SiteManager;

import javax.annotation.PostConstruct;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Named
@ViewScoped
public class ComponentView implements Serializable {

    private static final long serialVersionUID = -3003122957621343180L;

    private List<NetworkComponent> componentList;
    private NetworkComponent selectedComponent, addComponent;
    private ExportType exportType;
    private String fileName;

    @Inject
    private SiteService siteService;

    @Inject
    private ComponentService componentService;

    @PostConstruct
    public void init() {
        NetworkSite selectedSite = siteService.findById(SiteManager.getCurrentSite().getId());
        SiteManager.setCurrentSite(selectedSite);

        fileName = selectedSite.getName() + "-" + new SimpleDateFormat("YYYY-MM-DD").format(new Date());

        if (selectedSite.getTopology() == null) return;
        componentList = new ArrayList<>();
        componentList.addAll(selectedSite.getTopology().getComponents());

        addComponent = new NetworkComponent();
    }

    public List<NetworkComponent> getComponentList() {
        return componentList;
    }

    public void setComponentList(List<NetworkComponent> componentList) {
        this.componentList = componentList;
    }

    public NetworkComponent getSelectedComponent() {
        return selectedComponent;
    }

    public void setSelectedComponent(NetworkComponent selectedComponent) {
        this.selectedComponent = selectedComponent;
    }

    public NetworkComponent getAddComponent() {
        return addComponent;
    }

    public void setAddComponent(NetworkComponent addComponent) {
        this.addComponent = addComponent;
    }

    public ExportType getExportType() {
        return exportType;
    }

    public void setExportType(ExportType exportType) {
        this.exportType = exportType;
    }

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public ComponentType[] getComponentTypes() {
        return ComponentType.values();
    }

    public ExportType[] getExportTypes() {
        return ExportType.values();
    }

    public void removeSelectedComponent() {
        if (selectedComponent == null) return;
        NetworkSite site = SiteManager.getCurrentSite();
        site.getTopology().getComponents().remove(selectedComponent);
        siteService.update(site);
        componentList.remove(selectedComponent);
        selectedComponent = null;
    }

    public void editSelectedComponent() {
        if (selectedComponent == null) return;
        NetworkSite site = SiteManager.getCurrentSite();
        site.getTopology().getComponents().remove(selectedComponent);
        site.getTopology().getComponents().add(selectedComponent);
        siteService.update(site);
    }

    public void addSelectedComponent() {
        NetworkSite site = SiteManager.getCurrentSite();
        componentService.save(addComponent);
        site.getTopology().getComponents().add(addComponent);
        siteService.update(site);
        init();
    }

}

presentation/src/main/java/omnidoc/presentation/model/diagram/EditableDiagramView.java
package omnidoc.presentation.model.diagram;

import omnidoc.business.domain.topology.NetworkComponent;
import omnidoc.business.domain.topology.NetworkTopology;
import omnidoc.presentation.manager.SiteManager;
import omnidoc.presentation.util.Resources;
import org.primefaces.PrimeFaces;
import org.primefaces.event.diagram.ConnectEvent;
import org.primefaces.event.diagram.ConnectionChangeEvent;
import org.primefaces.event.diagram.DisconnectEvent;
import org.primefaces.model.diagram.Connection;
import org.primefaces.model.diagram.DefaultDiagramModel;
import org.primefaces.model.diagram.DiagramModel;
import org.primefaces.model.diagram.Element;
import org.primefaces.model.diagram.connector.StraightConnector;
import org.primefaces.model.diagram.overlay.ArrowOverlay;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Named;
import java.io.Serializable;
import java.util.List;

@Named
@RequestScoped
public class EditableDiagramView implements Serializable {

    private static final long serialVersionUID = -6012752737484038801L;

    private DefaultDiagramModel model;

    private boolean suspendEvent;

    @PostConstruct
    public void init() {
        setupDiagram();
        NetworkTopology topology = SiteManager.getCurrentSite().getTopology();
        if (topology != null) {
            DefaultDiagramLayout layout = new DefaultDiagramLayout(topology);
            layout.applyLayout();
            populateDiagram(
                    layout.getElements(),
                    layout.getConnections()
            );
        }
    }

    public DiagramModel getModel() {
        return model;
    }

    /**
     * Consctruct Diagram and set default connector and overlays
     */
    private void setupDiagram() {
        model = new DefaultDiagramModel();
        model.setMaxConnections(-1);
        model.getDefaultConnectionOverlays().add(new ArrowOverlay(20, 20, 1, 1));
        StraightConnector connector = new StraightConnector();
        connector.setPaintStyle("{strokeStyle:' #" + Resources.Colors.primaryBlue + "', lineWidth:3}");
        connector.setHoverPaintStyle("{strokeStyle:' #" + Resources.Colors.accentYellowDark + "'}");
        model.setDefaultConnector(connector);
    }

    /**
     * Add elements and connections to diagram
     *
     * @param elements    to be added to diagram
     * @param connections to be added to diagram
     */
    private void populateDiagram(List<Element> elements, List<Connection> connections) {
        elements.forEach(element -> model.addElement(element));
        connections.forEach(connection -> model.connect(connection));
    }

    /**
     * Used in detail.xhtml to get icon according to component type displayed
     *
     * @param component displayed in diagram
     * @return path to image
     */
    public String getImagePath(NetworkComponent component) {
        switch (component.getType()) {
            case ROUTER:
                return Resources.Images.ROUTER_SMALL;
            case SWITCH:
                return Resources.Images.SWITCH_SMALL;
            case CLIENT:
                return Resources.Images.WORKSTATION_SMALL;
            default:
                return "";
        }
    }

    /**
     * AJAX connect event from diagram
     *
     * @param event ConnectEvent
     */
    public void onConnect(ConnectEvent event) {
        if (!suspendEvent) {
            FacesMessage msg = new FacesMessage(FacesMessage.SEVERITY_INFO, "Connected",
                    "From " + event.getSourceElement().getData() + " To " + event.getTargetElement().getData());

            FacesContext.getCurrentInstance().addMessage(null, msg);

            PrimeFaces.current().ajax().update("form:msgs");
        } else {
            suspendEvent = false;
        }
    }

    /**
     * AJAX disconnect event from diagram
     *
     * @param event DisconnectEvent
     */
    public void onDisconnect(DisconnectEvent event) {
        FacesMessage msg = new FacesMessage(FacesMessage.SEVERITY_INFO, "Disconnected",
                "From " + event.getSourceElement().getData() + " To " + event.getTargetElement().getData());

        FacesContext.getCurrentInstance().addMessage(null, msg);

        PrimeFaces.current().ajax().update("form:msgs");
    }

    /**
     * AJAX connection event from diagram
     *
     * @param event ConnectionChangeEvent
     */
    public void onConnectionChange(ConnectionChangeEvent event) {
        FacesMessage msg = new FacesMessage(FacesMessage.SEVERITY_INFO, "Connection Changed",
                "Original Source:" + event.getOriginalSourceElement().getData() +
                        ", New Source: " + event.getNewSourceElement().getData() +
                        ", Original Target: " + event.getOriginalTargetElement().getData() +
                        ", New Target: " + event.getNewTargetElement().getData());

        FacesContext.getCurrentInstance().addMessage(null, msg);

        PrimeFaces.current().ajax().update("form:msgs");
        suspendEvent = true;
    }

}

presentation/src/main/java/omnidoc/presentation/model/diagram/MindmapView.java
package omnidoc.presentation.model.diagram;

import omnidoc.business.domain.site.NetworkSite;
import omnidoc.business.domain.topology.ComponentType;
import omnidoc.business.domain.topology.NetworkComponent;
import omnidoc.business.services.site.SiteService;
import omnidoc.presentation.manager.SiteManager;
import org.primefaces.event.SelectEvent;
import org.primefaces.model.mindmap.DefaultMindmapNode;
import org.primefaces.model.mindmap.MindmapNode;

import javax.annotation.PostConstruct;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;

@Named
@ViewScoped
public class MindmapView implements Serializable {

    private static final long serialVersionUID = -2809769319088602839L;

    private static final String
            NODE_TYPE_ROUTER = "ROUTER",
            NODE_TYPE_SWITCH = "SWITCH",
            NODE_TYPE_CLIENT = "CLIENT",
            NODE_TYPE_IPS = "IPs";

    private NetworkSite site;

    private MindmapNode root, selectedNode;

    @Inject
    private SiteService siteService;

    public MindmapView() {
    }

    @PostConstruct
    public void init() {
        site = SiteManager.getCurrentSite();
        populateDiagram(site);
    }

    private void populateDiagram(NetworkSite site) {

        root = createPrimaryNode(site.getName());

        MindmapNode routerComponents = createNode(NODE_TYPE_ROUTER, true);
        MindmapNode switchComponents = createNode(NODE_TYPE_SWITCH, true);
        MindmapNode clientComponents = createNode(NODE_TYPE_CLIENT, true);
        MindmapNode ips = createNode(NODE_TYPE_IPS, true);

        root.addNode(routerComponents);
        root.addNode(switchComponents);
        root.addNode(clientComponents);
        root.addNode(ips);
    }

    public MindmapNode getRoot() {
        return root;
    }

    public MindmapNode getSelectedNode() {
        return selectedNode;
    }

    public void setSelectedNode(MindmapNode selectedNode) {
        this.selectedNode = selectedNode;
    }

    public void onNodeSelect(SelectEvent event) {
        MindmapNode node = (MindmapNode) event.getObject();
        if (!node.getChildren().isEmpty()) return;

        //populate if not already loaded
        Object o = node.getLabel();
        for (NetworkComponent c : site.getTopology().getComponents()) {
            if (isType(o, c, "ROUTER", ComponentType.ROUTER) ||
                    isType(o, c, "SWITCH", ComponentType.SWITCH) ||
                    isType(o, c, "CLIENT", ComponentType.CLIENT)) {
                node.addNode(createChild(c.getHostname(), c));
            } else if (o.equals("IPs")) {
                node.addNode(createChild(c.getIp(), c));
            }
        }
    }


    private boolean isType(Object label, NetworkComponent component, String name, ComponentType type) {
        return label.equals(name) && component.getType() == type;
    }

    private DefaultMindmapNode createChild(String name, Object data) {
        return new DefaultMindmapNode(name, data, "82c542", true);
    }

    public void onNodeDblselect(SelectEvent event) {
        this.selectedNode = (MindmapNode) event.getObject();
    }

    private DefaultMindmapNode createPrimaryNode(String label) {
        return new DefaultMindmapNode(label, null, "FFCC00", true);
    }

    private DefaultMindmapNode createNode(String label, boolean selectable) {
        return new DefaultMindmapNode(label, null, "6e9ebf", selectable);
    }
}

presentation/src/main/webapp/WEB-INF/includes/components.xhtml
<ui:composition
        xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://xmlns.jcp.org/jsf/html"
        xmlns:f="http://xmlns.jcp.org/jsf/core"
        xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
        xmlns:p="http://primefaces.org/ui">
    <h:form id="table-components">
        <p:dataTable id="component-content" value="#{componentView.componentList}" var="device" liveResize="true"
                     selectionMode="single" selection="#{componentView.selectedComponent}" rowKey="#{device.id}"
                     paginator="true" paginatorAlwaysVisible="true" paginatorPosition="bottom" rows="10" reflow="true"
                     resizableColumns="true"
                     paginatorTemplate="{CurrentPageReport}  {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {AddRow}">

            <f:facet name="{AddRow}">
                <p:commandButton type="button" onclick="PF('dlgAddComponent').show();"
                                 update="table-components:panelComponentDetail table-components:dlgEditComponent"
                                 icon="fa fa-plus"/>
            </f:facet>

            <p:column headerText="#{msg['hostName']}" sortBy="#{device.hostname}">
                <h:outputText value="#{device.hostname}"/>
            </p:column>

            <p:column headerText="#{msg['modelName']}" sortBy="#{device.modelName}">
                <h:outputText value="#{device.modelName}"/>
            </p:column>

            <p:column headerText="#{msg['ipAddress']}" sortBy="#{device.ip}">
                <h:outputText value="#{device.ip}"/>
            </p:column>

            <p:column headerText="#{msg['macAddress']}" sortBy="#{device.macs}">
                <!--<h:outputText value="#{device.macs}"/>-->
                <p:selectOneMenu style="width: 75%;">
                    <f:selectItems value="#{device.macs}" var="mac" itemLabel="#{mac}" itemValue="#{mac}"/>
                </p:selectOneMenu>
            </p:column>

            <p:column headerText="#{msg['type']}" sortBy="#{device.type}">
                <h:outputText value="#{device.type}"/>
            </p:column>

            <p:column headerText="#{msg['serialNumber']}" sortBy="#{device.serialNumber}">
                <h:outputText value="#{device.serialNumber}"/>
            </p:column>
        </p:dataTable>

        <p:contextMenu for="component-content">
            <p:menuitem value="#{msg['edit']}" update="table-components:panelComponentDetail dlgEditComponent"
                        icon="ui-icon-search"
                        oncomplete="PF('dlgEditComponent').show();"/>

            <p:menuitem value="#{msg['delete']}" icon="ui-icon-close"
                        onclick="PF('dlgRemoveComponent').show();"/>
        </p:contextMenu>

        <p:dialog header="#{msg_components['edit_component']}" id="dlgEditComponent"
                  widgetVar="dlgEditComponent" modal="true" showEffect="fade" hideEffect="fade" resizable="false">

            <p:outputPanel id="panelComponentDetail">
                <p:panelGrid columns="2" rendered="#{not empty componentView.selectedComponent}">
                    <h:outputText value="#{msg['hostName']}" style="width: 90%;"/>
                    <p:inputText value="#{componentView.selectedComponent.hostname}" style="width: 90%;"/>

                    <h:outputText value="#{msg['modelName']}"/>
                    <p:inputText value="#{componentView.selectedComponent.modelName}" style="width: 90%;"/>

                    <h:outputText value="#{msg['type']}"/>
                    <p:selectOneMenu value="#{componentView.selectedComponent.type}" style="width: 80%;">
                        <f:selectItems value="#{componentView.componentTypes}" var="type"
                                       itemLabel="#{msg['componentType.' += type.name()]}"
                                       itemValue="#{type}"/>
                    </p:selectOneMenu>

                    <h:outputText value="#{msg['ipAddress']}"/>
                    <p:inputText value="#{componentView.selectedComponent.ip}" style="width: 90%;"/>

                    <h:outputText value="#{msg['macAddress']}"/>
                    <p:selectOneMenu editable="true" style="width: 80%;">
                        <f:selectItems value="#{device.macs}" var="mac" itemLabel="#{mac}" itemValue="#{mac}"/>
                    </p:selectOneMenu>

                </p:panelGrid>
                <p:commandButton value="#{msg['save']}" update="component-content"
                                 actionListener="#{componentView.editSelectedComponent}"
                                 oncomplete="if (!args.validationFailed) { PF('dlgEditComponent').hide(); }"/>
            </p:outputPanel>
        </p:dialog>

        <p:dialog header="#{msg_components['add_component']}" id="dlgAddComponent"
                  widgetVar="dlgAddComponent" modal="true" showEffect="fade" hideEffect="fade" resizable="false">

            <p:panelGrid columns="2">
                <h:outputText value="#{msg['hostName']}"/>
                <p:inputText value="#{componentView.addComponent.hostname}" style="width: 90%;"/>

                <h:outputText value="#{msg['modelName']}"/>
                <p:inputText value="#{componentView.addComponent.modelName}" style="width: 90%;"/>

                <h:outputText value="#{msg['type']}"/>
                <p:selectOneMenu value="#{componentView.addComponent.type}" style="width: 80%;">
                    <f:selectItems value="#{componentView.componentTypes}" var="type"
                                   itemLabel="#{msg['componentType.' += type.name()]}"
                                   itemValue="#{type}"/>
                </p:selectOneMenu>

                <h:outputText value="#{msg['ipAddress']}"/>
                <p:inputText value="#{componentView.addComponent.ip}" style="width: 90%;"/>

                <h:outputText value="#{msg['macAddress']}"/>
                <p:selectOneMenu editable="true" style="width: 80%;">
                    <f:selectItems value="#{componentView.addComponent.macs}" var="mac" itemLabel="#{mac}"
                                   itemValue="#{mac}"/>
                </p:selectOneMenu>

            </p:panelGrid>
            <p:commandButton value="#{msg['save']}" update="component-content dlgAddComponent"
                             actionListener="#{componentView.addSelectedComponent}"
                             oncomplete="if (!args.validationFailed) { PF('dlgAddComponent').hide(); }"/>
        </p:dialog>

        <p:dialog header="#{msg['areYouSure']}" widgetVar="dlgRemoveComponent" modal="true" resizable="false"
                  showEffect="fade" hideEffect="fade">
            <p:commandButton value="#{msg['delete']}"
                             actionListener="#{componentView.removeSelectedComponent}"
                             styleClass="ui-g-12 ui-g-nopad"
                             update="component-content"
                             onclick="PF('dlgRemoveComponent').hide();"/>
        </p:dialog>

        <p:dialog header="Export" widgetVar="js-dlg-export" modal="true" resizable="false"
                  showEffect="fade" hideEffect="fade">
            <p:panelGrid id="pnlExport" columns="2" styleClass="ui-panelgrid-blank">
                <p:column>
                    <p:outputLabel value="#{msg_components['exportAs']}"/>
                </p:column>
                <p:column>
                    <p:selectOneMenu value="#{componentView.exportType}">
                        <p:ajax event="change" update="pnlExport"/>
                        <f:selectItem itemLabel="#{msg['pleaseChoose']}" itemValue=""/>
                        <f:selectItems value="#{componentView.exportTypes}" var="expTyp"
                                       itemLabel="#{msg_components['exportType.' += expTyp.name()]} #{msg_components['file']}"
                                       itemValue="#{expTyp}"/>
                    </p:selectOneMenu>
                </p:column>

                <p:column>
                    <p:outputLabel value="#{msg_components['fileName']}"/>
                </p:column>
                <p:column>
                    <div class="ui-inputgroup">
                        <p:inputText value="#{componentView.fileName}"/>
                        <span class="ui-inputgroup-addon" style="border: 1px solid #d2d2d2;">
                            #{empty componentView.exportType.type ? '' : '.' += componentView.exportType.type}
                        </span>
                    </div>
                </p:column>

                <p:column/>
                <p:column>
                    <p:commandButton value="#{msg_components['export']}" ajax="false"
                                     icon="fa fa-file-excel-o" style="width: 100%;"
                                     disabled="#{empty componentView.exportType}">
                        <p:dataExporter type="#{componentView.exportType.type}" target="component-content"
                                        fileName="#{componentView.fileName}"/>
                    </p:commandButton>
                </p:column>
            </p:panelGrid>
        </p:dialog>
    </h:form>
</ui:composition>

presentation/src/main/webapp/WEB-INF/includes/donut-chart.xhtml
<ui:composition
        xmlns="http://www.w3.org/1999/xhtml"
        xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
        xmlns:p="http://primefaces.org/ui">
    <div id="stats-container">
        <p:chart type="donut" model="#{donutChartView.donutModel}" style="width:400px;height:300px"/></div>
</ui:composition>

presentation/src/main/webapp/WEB-INF/includes/editable-diagram.xhtml
<ui:composition
        xmlns="http://www.w3.org/1999/xhtml"
        xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
        xmlns:h="http://xmlns.jcp.org/jsf/html"
        xmlns:f="http://xmlns.jcp.org/jsf/core"
        xmlns:p="http://primefaces.org/ui">
    <div id="editable-diagram">
        <h:form id="form">
            <p:growl id="msgs" showDetail="true"/>

            <p:diagram value="#{editableDiagramView.model}" style="height:500px;"
                       styleClass="ui-widget-content"
                       var="el" id="editable-diagram-content">
                <f:facet name="element">
                    <h:outputText value="#{el.label}" style="display:block;margin-top:1em;"/>
                    <p:graphicImage name="#{editableDiagramView.getImagePath(el)}"/>
                </f:facet>
                <p:ajax event="connect" listener="#{editableDiagramView.onConnect}"/>
                <p:ajax event="disconnect" listener="#{editableDiagramView.onDisconnect}"/>
                <p:ajax event="connectionChange" listener="#{editableDiagramView.onConnectionChange}"/>
            </p:diagram>
        </h:form>
    </div>

    <style type="text/css">
        #editable-diagram .ui-diagram-element {
            border: 0.1em dotted #E5E4E2;
            background-color: #EFEEEC;
            width: 10em;
            height: 8em;
            text-align: center;
            box-shadow: 0 5px 10px rgba(0, 0, 0, 0.8);
        }

        #editable-diagram .ui-diagram-element:hover {
            background-color: #C7C6C4;
        }
    </style>
</ui:composition>

presentation/src/main/webapp/WEB-INF/includes/hello.xhtml
<ui:composition
        xmlns="http://www.w3.org/1999/xhtml"
        xmlns:ui="http://xmlns.jcp.org/jsf/facelets">
    <h1>Guten Abend!</h1>
</ui:composition>

presentation/src/main/webapp/WEB-INF/includes/mindmap.xhtml
<ui:composition
        xmlns="http://www.w3.org/1999/xhtml"
        xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
        xmlns:h="http://xmlns.jcp.org/jsf/html"
        xmlns:p="http://primefaces.org/ui">
    <h:form>
        <p:mindmap value="#{mindmapView.root}" style="height: 400px;" id="mindmap-content">
            <p:ajax event="select" listener="#{mindmapView.onNodeSelect}" oncomplete="mindmapSelectCallback()"/>
            <p:ajax event="dblselect" listener="#{mindmapView.onNodeDblselect}" update="pnlComponentDetail"
                    oncomplete="PF('dlgShowComponent').show();"/>
        </p:mindmap>

        <p:dialog widgetVar="dlgShowComponent" header="#{msg['show_component']}" modal="true"
                  showEffect="fade" hideEffect="fade" resizable="false">

            <p:outputPanel id="pnlComponentDetail">
                <p:panelGrid columns="2" rendered="#{not empty mindmapView.selectedNode.data}">
                    <h:outputText value="#{msg['id']}:"/>
                    <h:outputText value="#{mindmapView.selectedNode.data.id}"/>

                    <h:outputText value="#{msg['hostName']}"/>
                    <h:outputText value="#{mindmapView.selectedNode.data.hostname}"/>

                    <h:outputText value="#{msg['modelName']}"/>
                    <h:outputText value="#{mindmapView.selectedNode.data.modelName}"/>

                    <h:outputText value="#{msg['type']}"/>
                    <h:outputText value="#{mindmapView.selectedNode.data.type}"/>

                    <h:outputText value="#{msg['ipAddress']}"/>
                    <h:outputText value="#{mindmapView.selectedNode.data.ip}"/>

                    <h:outputText value="#{msg['macAddress']}"/>
                    <h:outputText value="#{mindmapView.selectedNode.data.macs}"/>
                </p:panelGrid>
            </p:outputPanel>
        </p:dialog>

    </h:form>
</ui:composition>

presentation/src/main/webapp/WEB-INF/includes/simple-diagram.xhtml
<ui:composition
        xmlns="http://www.w3.org/1999/xhtml"
        xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
        xmlns:p="http://primefaces.org/ui">
    <div id="diagram-container">
        <p:diagram value="#{basicDiagramView.model}" style="height:500px; width: 1000px" id="diagram-content"/>
    </div>
    <style type="text/css">
        #diagram-container .ui-diagram-element {
            border: 0.1em dotted #d4e06b;
            width: 14em;
            height: 4em;
            line-height: 4em;
            text-align: center;
        }
    </style>
</ui:composition>